## mingw-w64-qt6-multimedia-6.9.1-2.src.tar.zst

=== CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

# Generated from qtmultimedia.pro.

cmake_minimum_required(VERSION 3.16)

include(.cmake.conf)
project(QtMultimedia
    VERSION "${QT_REPO_MODULE_VERSION}"
    DESCRIPTION "Qt Multimedia Libraries"
    HOMEPAGE_URL "https://qt.io/"
    LANGUAGES CXX C
)

find_package(Qt6 ${PROJECT_VERSION} CONFIG REQUIRED COMPONENTS BuildInternals Core)
find_package(Qt6 ${PROJECT_VERSION} QUIET CONFIG OPTIONAL_COMPONENTS Gui Network Svg Widgets Quick Qml Test QuickTest QuickControls2 Quick3D OpenGLPrivate)
qt_internal_project_setup()

if(NOT TARGET Qt::Gui)
    message(NOTICE "Skipping the build as the condition \"TARGET Qt::Gui\" is not met.")
    return()
endif()

if(QNX AND CMAKE_SYSTEM_VERSION GREATER_EQUAL 800)
    message(NOTICE "Skipping the build as multimedia is not supported on QNX8.0.")
    return()
endif()

include(src/multimedia/Qt6MultimediaMacros.cmake)

set(QT_BUILD_EXTRA_IDE_FILE_PATTERNS
    src/multimedia/doc/QtMultimediaDoc
    src/multimedia/doc/qtmultimedia.qdocconf
    src/multimedia/doc/snippets/CMakeLists.txt
    src/multimedia/doc/snippets/multimedia-snippets/audio.cpp
    src/multimedia/doc/snippets/multimedia-snippets/camera.cpp
    src/multimedia/doc/snippets/multimedia-snippets/devices.cpp
    src/multimedia/doc/snippets/multimedia-snippets/images/qt-logo.png
    src/multimedia/doc/snippets/multimedia-snippets/media.cpp
    src/multimedia/doc/snippets/multimedia-snippets/multiple-videooutputs.qml
    src/multimedia/doc/snippets/multimedia-snippets/qsound.cpp
    src/multimedia/doc/snippets/multimedia-snippets/qtvideosink.qml
    src/multimedia/doc/snippets/multimedia-snippets/soundeffect.qml
    src/multimedia/doc/snippets/multimedia-snippets/video.cpp
    src/multimedia/doc/src/audiooverview.qdoc
    src/multimedia/doc/src/backend-notes-apple.qdoc
    src/multimedia/doc/src/cameraoverview.qdoc
    src/multimedia/doc/src/classic.css
    src/multimedia/doc/src/multimedia-overview.qdoc
    src/multimedia/doc/src/platform-notes-apple.qdoc
    src/multimedia/doc/src/platform-notes-wasm.qdoc
    src/multimedia/doc/src/platform-notes-wayland.qdoc
    src/multimedia/doc/src/qm-external-pages.qdoc
    src/multimedia/doc/src/qt6-changes.qdoc
    src/multimedia/doc/src/qtmultimedia-building-from-source.qdoc
    src/multimedia/doc/src/qtmultimedia-cpp.qdoc
    src/multimedia/doc/src/qtmultimedia-examples.qdoc
    src/multimedia/doc/src/qtmultimedia-index.qdoc
    src/multimedia/doc/src/qtmultimedia-qml-types.qdoc
    src/multimedia/doc/src/videooverview.qdoc
    src/multimedia/doc/src/advanced-ffmpeg-configuration.qdoc
    src/multimedia/doc/src/images/Zoom.gif
    src/multimedia/doc/src/images/annotatedurl.png
    src/multimedia/doc/src/images/camera_correctionAngle_90.png
    src/multimedia/doc/src/images/codeless.png
    src/multimedia/doc/src/images/how-focus-works.gif
    src/multimedia/doc/src/images/image_processing.png
    src/multimedia/doc/src/images/noun_Media_166644.svg
    src/multimedia/doc/src/images/qS1FmgPVL.jpg
    src/multimedia/doc/src/images/qmlcamera-menu.png
    src/multimedia/doc/src/images/radio-example.png
    src/multimedia/doc/src/images/slideshow-img1.png
    src/multimedia/doc/src/images/sound-wave-small.jpg
    src/multimedia/doc/src/images/video-graphics-memory.png

)

qt_build_repo()

=== src/plugins/multimedia/android/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

qt_internal_add_plugin(QAndroidMediaPlugin
    OUTPUT_NAME androidmediaplugin
    PLUGIN_TYPE multimedia
    SOURCES
        common/qandroidaudiooutput_p.h
        common/qandroidaudioinput.cpp common/qandroidaudioinput_p.h
        audio/qandroidaudiodecoder.cpp audio/qandroidaudiodecoder_p.h
        common/qandroidglobal_p.h
        common/qandroidmultimediautils.cpp common/qandroidmultimediautils_p.h
        common/qandroidvideosink.cpp common/qandroidvideosink_p.h
        common/qandroidvideooutput.cpp common/qandroidvideooutput_p.h
        mediacapture/qandroidcamera.cpp mediacapture/qandroidcamera_p.h
        mediacapture/qandroidimagecapture.cpp mediacapture/qandroidimagecapture_p.h
        mediacapture/qandroidcamerasession.cpp mediacapture/qandroidcamerasession_p.h
        mediacapture/qandroidmediacapturesession.cpp mediacapture/qandroidmediacapturesession_p.h
        mediacapture/qandroidcapturesession.cpp mediacapture/qandroidcapturesession_p.h
        mediacapture/qandroidmediaencoder.cpp mediacapture/qandroidmediaencoder_p.h
        mediaplayer/qandroidmediaplayer.cpp mediaplayer/qandroidmediaplayer_p.h
        mediaplayer/qandroidmetadata.cpp mediaplayer/qandroidmetadata_p.h
        qandroidformatsinfo.cpp  qandroidformatsinfo_p.h
        qandroidintegration.cpp qandroidintegration_p.h
        wrappers/jni/androidcamera.cpp wrappers/jni/androidcamera_p.h
        wrappers/jni/androidmediametadataretriever.cpp wrappers/jni/androidmediametadataretriever_p.h
        wrappers/jni/androidmediaplayer.cpp wrappers/jni/androidmediaplayer_p.h
        wrappers/jni/androidmediarecorder.cpp wrappers/jni/androidmediarecorder_p.h
        wrappers/jni/androidmultimediautils.cpp wrappers/jni/androidmultimediautils_p.h
        wrappers/jni/androidsurfacetexture.cpp wrappers/jni/androidsurfacetexture_p.h
        wrappers/jni/androidsurfaceview.cpp wrappers/jni/androidsurfaceview_p.h
    NO_UNITY_BUILD_SOURCES
        # Resolves two problems:
        #   - Collision of `rwLock` with wrappers/jni/androidmediaplayer.cpp
        #   - and redefinition of `notifyFrameAvailable` with different signature
        #     with wrappers/jni/androidsurfacetexture.cpp
        wrappers/jni/androidcamera.cpp
    INCLUDE_DIRECTORIES
        audio
        common
        mediacapture
        mediaplayer
        wrappers/jni
        ../android
    DEFINES
        QT_NO_CAST_FROM_ASCII
        QT_NO_CAST_TO_ASCII
        QT_NO_CONTEXTLESS_CONNECT
    LIBRARIES
        Qt::MultimediaPrivate
        Qt::CorePrivate
        OpenSLES
        mediandk
)

set_property(TARGET QAndroidMediaPlugin APPEND PROPERTY QT_ANDROID_BUNDLED_JAR_DEPENDENCIES
    jar/Qt${QtMultimedia_VERSION_MAJOR}AndroidMultimedia.jar
)
set_property(TARGET QAndroidMediaPlugin APPEND PROPERTY QT_ANDROID_LIB_DEPENDENCIES
    ${INSTALL_PLUGINSDIR}/multimedia/libplugins_multimedia_androidmediaplugin.so
)
set_property(TARGET QAndroidMediaPlugin APPEND PROPERTY QT_ANDROID_PERMISSIONS
    android.permission.CAMERA android.permission.RECORD_AUDIO
    android.permission.BLUETOOTH
    android.permission.MODIFY_AUDIO_SETTINGS
)

=== src/plugins/multimedia/darwin/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause


qt_internal_add_plugin(QDarwinMediaPlugin
    OUTPUT_NAME darwinmediaplugin
    PLUGIN_TYPE multimedia
    SOURCES
        avfaudiodecoder.mm avfaudiodecoder_p.h
        mediaplayer/avfdisplaylink.mm mediaplayer/avfdisplaylink_p.h
        mediaplayer/avfmediaplayer.mm mediaplayer/avfmediaplayer_p.h
        common/avfmetadata.mm common/avfmetadata_p.h
        mediaplayer/avfvideorenderercontrol.mm mediaplayer/avfvideorenderercontrol_p.h
        avfvideosink.mm avfvideosink_p.h
        avfvideobuffer.mm avfvideobuffer_p.h
        qdarwinformatsinfo.mm qdarwinformatsinfo_p.h
        qdarwinintegration.mm qdarwinintegration_p.h
    INCLUDE_DIRECTORIES
        audio
        camera
        common
        mediaplayer
    DEFINES
        QT_NO_CAST_FROM_ASCII
        QT_NO_CAST_TO_ASCII
        QT_NO_CONTEXTLESS_CONNECT
    LIBRARIES
        Qt::MultimediaPrivate
        Qt::CorePrivate
        ${FWAudioToolbox}
        ${FWCoreMedia}
        ${FWCoreVideo}
        ${FWFoundation}
        ${FWMetal}
        ${FWQuartzCore}
        AVFoundation::AVFoundation
)

qt_internal_extend_target(QDarwinMediaPlugin CONDITION NOT TVOS AND NOT VISIONOS
    SOURCES
        camera/qavfcamerabase.mm camera/qavfcamerabase_p.h
        camera/avfcamera.mm camera/avfcamera_p.h
        camera/avfaudiopreviewdelegate.mm camera/avfaudiopreviewdelegate_p.h
        camera/avfcamerarenderer.mm camera/avfcamerarenderer_p.h
        camera/avfcameraservice.mm camera/avfcameraservice_p.h
        camera/avfcamerasession.mm camera/avfcamerasession_p.h
        camera/avfimagecapture.mm camera/avfimagecapture_p.h
        camera/avfmediaassetwriter.mm camera/avfmediaassetwriter_p.h
        camera/avfmediaencoder.mm camera/avfmediaencoder_p.h
)

qt_internal_extend_target(QDarwinMediaPlugin CONDITION MACOS
    LIBRARIES
        ${FWAppKit}
        ${FWAudioUnit}
        ${FWVideoToolbox}
        ${FWApplicationServices}
)

qt_internal_extend_target(QDarwinMediaPlugin CONDITION IOS OR VISIONOS
    LIBRARIES
        ${FWCoreGraphics}
        ${FWCoreVideo}
)

=== tests/auto/unit/multimedia/qaudionamespace/CMakeLists.txt ===
# Copyright (C) 2022 The Qt Company Ltd.
# SPDX-License-Identifier: BSD-3-Clause

#####################################################################
## tst_qaudionamespace Test:
#####################################################################

qt_internal_add_test(tst_qaudionamespace
    SOURCES
        tst_qaudionamespace.cpp
    LIBRARIES
        Qt::Gui
        Qt::MultimediaPrivate
)

=== PKGBUILD ===
# Contributor: Mehdi Chinoune <mehdi.chinoune@hotmail.com>

_realname=qt6-multimedia
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}"
         "${MINGW_PACKAGE_PREFIX}-${_realname}-debug"
         "${MINGW_PACKAGE_PREFIX}-${_realname}-ffmpeg"
         "${MINGW_PACKAGE_PREFIX}-${_realname}-wmf")
_qtver=6.9.1
pkgver=${_qtver/-/}
pkgrel=2
pkgdesc='Classes for audio, video, radio and camera functionality (mingw-w64)'
arch=(any)
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url='https://www.qt.io'
msys2_repository_url="https://code.qt.io/cgit/qt/qtmultimedia.git"
msys2_references=(
  'archlinux: qt6-multimedia'
  "cpe: cpe:/a:qt:qt"
)
license=('spdx:LGPL-3.0-only WITH Qt-GPL-exception-1.0 AND BSD-3-Clause AND GFDL-1.3-no-invariants-only AND GPL-2.0-only AND GPL-3.0-only')
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-qt6-declarative"
             "${MINGW_PACKAGE_PREFIX}-qt6-shadertools"
             "${MINGW_PACKAGE_PREFIX}-qt6-quick3d"
             "${MINGW_PACKAGE_PREFIX}-ffmpeg"
             #"${MINGW_PACKAGE_PREFIX}-pulseaudio"
             "rsync")
_pkgfn="${_realname/6-/}-everywhere-src-${_qtver}"
source=("https://download.qt.io/official_releases/qt/${pkgver%.*}/${_qtver}/submodules/${_pkgfn}.tar.xz"
        001-export-some-constexpr-variables.patch
        https://github.com/qt/qtmultimedia/commit/65b11b9f97632101041134e04713697b17819884.patch)
sha256sums=('955e36459518ee55f8e2bb79defc6e44aa94dc1edf5ac58a22d7734b2e07391d'
            'e1694338779eb499341618c62d11f832f2b7f1f90c8a20345932530a61203105'
            'd10a23df7a502bca0c54f7ecbfab71e4c4794eac0340ead8384d28ccc0443e94')

prepare() {
  cd "${srcdir}"/${_pkgfn}
  if [[ ${MINGW_PACKAGE_PREFIX} != *-clang-* ]]; then
    patch -p1 -i "${srcdir}"/001-export-some-constexpr-variables.patch
  fi
  patch -p1 -i "${srcdir}"/65b11b9f97632101041134e04713697b17819884.patch
}

build() {
  mkdir -p build-${MSYSTEM} && cd build-${MSYSTEM}

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake \
    --log-level=STATUS \
    -GNinja \
    -DCMAKE_BUILD_TYPE=RelWithDebInfo \
    -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
    -DFEATURE_wmf=ON \
    -DFEATURE_gstreamer=OFF \
    ../${_pkgfn}

  ${MINGW_PREFIX}/bin/cmake --build .
}

package_qt6-multimedia() {
  depends=("${MINGW_PACKAGE_PREFIX}-qt6-base"
           "${MINGW_PACKAGE_PREFIX}-qt6-shadertools"
           "${MINGW_PACKAGE_PREFIX}-qt6-multimedia-ffmpeg")
  optdepends=("${MINGW_PACKAGE_PREFIX}-qt6-declarative"
              "${MINGW_PACKAGE_PREFIX}-qt6-quick3d"
              "${MINGW_PACKAGE_PREFIX}-qt6-multimedia-wmf")
  groups=("${MINGW_PACKAGE_PREFIX}-qt6")

  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake --install build-${MSYSTEM}

  # Seperate debug-info files
  rsync -armR --remove-source-files --include="*/" --include="*.debug" --exclude="*" --prune-empty-dirs "${pkgdir}"/.${MINGW_PREFIX} "${srcdir}"/${MSYSTEM}-debug/

  install -d "$pkgdir${MINGW_PREFIX}"/share/licenses/${_realname}
  install -Dm644 $_pkgfn/LICENSES/* -t "$pkgdir${MINGW_PREFIX}"/share/licenses/${_realname}

  # Split plugins
  rm -r "${pkgdir}${MINGW_PREFIX}/share/qt6/plugins"
  rm "${pkgdir}${MINGW_PREFIX}"/lib/cmake/Qt6Multimedia/Qt6Q{FFmpeg,Windows}MediaPlugin*
  rm -r "${pkgdir}${MINGW_PREFIX}"/lib/cmake/Qt6FFmpegMediaPluginImplPrivate
  rm -r "${pkgdir}${MINGW_PREFIX}"/include/qt6/QtFFmpegMediaPluginImpl/
  rm -r "${pkgdir}${MINGW_PREFIX}"/lib/libQt6FFmpegMediaPluginImpl.a
  rm -r "${pkgdir}${MINGW_PREFIX}"/share/qt6/metatypes/qt6ffmpegmediapluginimplprivate_relwithdebinfo_metatypes.json
  rm -r "${pkgdir}${MINGW_PREFIX}"/share/qt6/mkspecs/modules/qt_lib_ffmpegmediapluginimpl_private.pri
  rm -r "${pkgdir}${MINGW_PREFIX}"/share/qt6/modules/FFmpegMediaPluginImplPrivate.json
}

package_qt6-multimedia-debug() {
  depends=("${MINGW_PACKAGE_PREFIX}-qt6-base-debug"
           "${MINGW_PACKAGE_PREFIX}-qt6-shadertools-debug"
           "${MINGW_PACKAGE_PREFIX}-${_realname}")
  groups=("${MINGW_PACKAGE_PREFIX}-qt6-debug")
  options=('!strip')

  cp -rf "${srcdir}"/${MSYSTEM}-debug${MINGW_PREFIX} "${pkgdir}"/
}

package_qt6-multimedia-ffmpeg() {
  pkgdesc='FFMpeg backend for qt6-multimedia'
  depends=("${MINGW_PACKAGE_PREFIX}-ffmpeg"
           "${MINGW_PACKAGE_PREFIX}-${_realname}")

  DESTDIR="$pkgdir" ${MINGW_PREFIX}/bin/cmake --install build-${MSYSTEM}/src/plugins/multimedia/ffmpeg

  find "${pkgdir}${MINGW_PREFIX}" -type f -name '*.debug' -delete
}

package_qt6-multimedia-wmf() {
  pkgdesc='Windows Media Foundation backend for qt6-multimedia'
  depends=("${MINGW_PACKAGE_PREFIX}-${_realname}")

  DESTDIR="$pkgdir" ${MINGW_PREFIX}/bin/cmake --install build-${MSYSTEM}/src/plugins/multimedia/windows

  find "${pkgdir}${MINGW_PREFIX}" -type f -name '*.debug' -delete
}

# template start; name=mingw-w64-splitpkg-wrappers; version=1.0;
# vim: set ft=bash :

# generate wrappers
for _name in "${pkgname[@]}"; do
  _short="package_${_name#${MINGW_PACKAGE_PREFIX}-}"
  _func="$(declare -f "${_short}")"
  eval "${_func/#${_short}/package_${_name}}"
done
# template end;
